# create-web3

A boilerplate for creating a web3 projects

This boilerplate quickly creates a mono repo with 2 environments, a react frontend environment and a Ethereum development environment for writing, testing and deploying contracts.

<p>
  <a href="https://www.npmjs.com/package/create-web3">
    <img src="https://img.shields.io/npm/v/create-web3" alt="Version">
  </a>
    <a href="https://www.npmjs.com/package/create-web3">
    <img src="https://img.shields.io/npm/dm/create-web3" alt="Downloads per month">
  </a>
  <a href="/LICENSE">
    <img src="https://img.shields.io/npm/l/create-web3" alt="License">
  </a>
</p>

## Quick Start Notes

1.  To start install

```bash
npx create-web3
```

2.  Run `yarn` or `npm install` to install all the dependencies
3.  Once installation is complete, `cd` into your app's directory and run `yarn chain` or `npm run chain` to start a local hardhat environment
4.  Open another terminal and `cd` into your app's directory
5.  Run `yarn deploy` or `npm run deploy` to deploy the example contract locally
6.  Run `yarn dev` or `npm run dev` to start your Next dev environment

## Technologies

This project is built with the following open source libraries, frameworks and languages. User choice of framework used, available in plain js or typescript.
| Tech | Description |
| --------------------------------------------- | ------------------------------------------------------------------ |
| ------ | ------ React Frontend Environment ------ |
| [Next JS](https://nextjs.org/) | React Framework |
| [Vite JS](https://vitejs.dev/) | Next Generation Frontend Tooling |
| ------ | ------ CSS Framework ------ |
| none | |
| [Tailwind](https://tailwindcss.com/) | A utility-first CSS framework |
| [Chakra](https://chakra-ui.com/) | A simple, modular and accessible component library that gives you the building blocks you need to build your React applications. |
| ------ | ------ Ethereum Development Environment ------ |
| [Hardhat](https://hardhat.org/) | Ethereum development environment for professionals |
| [Foundry](https://getfoundry.sh/) | a blazing fast, portable and modular toolkit for Ethereum application development written in Rust. |
| ------ | ------ Included Libraries ------ |
| [WAGMI](https://wagmi.sh/) | A set of React Hooks for Web3 |
| [RainbowKit](https://www.rainbowkit.com/docs/introduction) | RainbowKit is a React library that makes it easy to add wallet connection to your dapp. |

## Documentation

Please visit [create-web3.xyz](https://create-web3.xyz) to view the full documentation.

## Discussions

If you have questions how to use, want to suggest a feature, or show off a project you created with create-web3, join [discussions on GitHub](https://github.com/e-roy/create-web3/discussions). I would love to hear from you. 🙂

## Issues

If you find a bug or would like to request a feature, please visit [ISSUES](https://github.com/e-roy/create-web3/issues)
